--- kernel-ide.SlackBuild	2006-09-01 02:51:30.000000000 -0400
+++ kernel-default.SlackBuild.s390x	2009-05-05 00:17:06.000000000 -0400
@@ -1,82 +1,64 @@
 #!/bin/sh
-TMP=/tmp
-CWD=`pwd`
-PKG=/tmp/package-kernel
 
-# Fill this stuff in:
-
-KERNNAME=ide
+PRGNAM=kernel-default
 VERSION=${VERSION:-2.4.33.3}
-ARCH=${ARCH:-i486}
+ARCH=${ARCH:-s390x}
 BUILD=${BUILD:-1}
 
-# First try to find the loot in the current dir, then look
-# in /usr/src/linux-$VERSION:
-if [ -r $CWD/bzImage ]; then
-  KERNEL=$CWD/bzImage
-elif [ -r $CWD/vmlinuz ]; then
-  KERNEL=$CWD/vmlinuz
-elif [ -r $CWD/vmlinuz* ]; then
-  KERNEL=$CWD/vmlinuz*
-else 
-  KERNEL=/usr/src/linux-$VERSION/arch/i386/boot/bzImage
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=${TMP}/package-${PRGNAM}
+
+NUMJOBS=${NUMJOBS:--j3}
+
+if [ "${ARCH}" = "i486" ]; then
+  SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+elif [ "${ARCH}" = "i686" ]; then
+  SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+elif [ "${ARCH}" = "s390x" ]; then
+  SLKCFLAGS="-O2"
+elif [ "${ARCH}" = "x86_64" ]; then
+  SLKCFLAGS="-O2 -fPIC"
 fi
 
-if [ -r $CWD/System.map.gz ]; then
-  gzip -d $CWD/System.map.gz
-elif [ -r $CWD/System.map.bz2 ]; then
-  bzip2 -d $CWD/System.map.bz2
-fi
+rm -rf ${TMP}/${PRGNAM}-${VERSION} ${PKG}
+mkdir -p ${TMP}/${PRGNAM}-${VERSION}/usr/src ${PKG}
+cd ${TMP}/${PRGNAM}-${VERSION}/usr/src || exit 1
+echo "Unpacking the tarball.  Please wait..."
+tar -jxf ${CWD}/../../k/linux-${VERSION}.tar.bz2
+
+cd linux-${VERSION} || exit 1
+chown -R root.root .
+chmod -R a-s,u+rw,go-w .
+
+zcat ${CWD}/../../k/s390-patches/lnx24333-36.timer.gz | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/reiserfs.strcpy.fix.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/dasd_int.h.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/chandev.c.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/tape.h.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/tubttybld.c.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/qeth.c.diff | patch -p1 || exit 1
+cat ${CWD}/../../k/s390-patches/lcs.c.diff | patch -p1 || exit 1
+
+cp -vpi ${CWD}/../../k/config-s390-${VERSION} .config || exit 1
+ARCH="s390" make oldconfig || exit 1
+ARCH="s390" make dep || exit 1
+ARCH="s390" make ${NUMJOBS} image || exit 1
+
+mkdir ${PKG}/boot ${PKG}/install
+cp -p arch/s390x/boot/image ${PKG}/boot/image-${VERSION}
+cp -p System.map ${PKG}/boot/System.map-${VERSION}
+cp -p ${CWD}/../../k/config-s390-${VERSION} \
+    ${PKG}/boot/config-${VERSION}
+
+cd ${PKG}/boot
+rm -f System.map ; ln -s System.map-${VERSION} System.map
+rm -f image      ; ln -s image-${VERSION} image
+rm -f config     ; ln -s config-${VERSION} config
 
-if [ -r $CWD/System.map ]; then
-  SYSMAP=$CWD/System.map
-elif [ -r $CWD/System.map* ]; then
-  SYSMAP=$CWD/System.map*
-else
-  SYSMAP=/usr/src/linux-$VERSION/System.map
-fi
-if [ -r $CWD/config ]; then
-  CONFIG=$CWD/config
-elif [ -r $CWD/config* ]; then
-  CONFIG=$CWD/config*
-elif [ -r $CWD/.config ]; then
-  CONFIG=$CWD/.config
-else
-  CONFIG=/usr/src/linux-$VERSION/.config
-fi
+cd ${PKG}/install
+cat ${CWD}/slack-desc.s390 > slack-desc 
+
+cd ${PKG}
+makepkg -c n -l y ../${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz
 
-cat << EOF
-Building kernel-$KERNNAME-$VERSION-$ARCH-$BUILD.tgz
-using these source files.  Please check and then hit 
-enter to make the package.
-
-KERNEL = $KERNEL
-SYSMAP = $SYSMAP
-CONFIG = $CONFIG
-
-EOF
-read junk;
-
-rm -rf $PKG
-mkdir -p $PKG
-mkdir -p $PKG/boot
-cp $KERNEL $PKG/boot/vmlinuz-$KERNNAME-$VERSION
-rdev -R $PKG/boot/vmlinuz-$KERNNAME-$VERSION 0
-rdev -v $PKG/boot/vmlinuz-$KERNNAME-$VERSION -1
-rdev -r $PKG/boot/vmlinuz-$KERNNAME-$VERSION 0
-( cd $PKG/boot ; ln -sf vmlinuz-$KERNNAME-$VERSION vmlinuz )
-cp $SYSMAP $PKG/boot/System.map-$KERNNAME-$VERSION
-( cd $PKG/boot ; ln -sf System.map-$KERNNAME-$VERSION System.map )
-cp $CONFIG $PKG/boot/config-$KERNNAME-$VERSION
-( cd $PKG/boot ; ln -sf config-$KERNNAME-$VERSION config )
-mkdir -p $PKG/install
-cat $CWD/slack-desc > $PKG/install/slack-desc
-
-# Build the package:
-cd $PKG
-makepkg -l y -c n $TMP/kernel-$KERNNAME-$VERSION-$ARCH-$BUILD.tgz
-
-# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
-  rm -rf $PKG
-fi
